#
# GroupSketch Conference Application
# ----------------------------------
#
# Here is a generic whiteboard like application, allowing the user to do
# freehand drawing (although not erasing).  The drawings are kept as lines
# on a canvas widget.

#source "conf.tcl"
gk_initConf $argv


#
# set up canvas and various bindings; essentially call a routine to draw
# a line when the mouse is moved with the left button down.

gk_defaultMenu .menu
canvas .c 
pack append . .menu {top fillx} .c top
set lastX 0
set lastY 0

set cursors(0) ""
bind .c <1> "global lastX lastY; set lastX %x; set lastY %y"
bind .c <B1-Motion> {  doit %x %y }

#
# This routine draws the lines, in response to dragging with mouse button 1
# pressed.  Draw the line in our canvas, and then send the line to all the
# other users
#
proc doit {x y} { global lastX lastY lineId
    gk_toAll .c create line $lastX $lastY $x $y
    set lastX $x; set lastY $y
}


# New entrants are updated by way of the following procedure and trace.
trace variable gk_entrantUserNum w {updateEntrant .c}
proc updateEntrant {canvas args} { global gk_entrantUserNum
    foreach i [$canvas find all] {
	set x1 [lindex [$canvas coords $i] 0]
	set y1 [lindex [$canvas coords $i] 1]
	set x2 [lindex [$canvas coords $i] 2]
	set y2 [lindex [$canvas coords $i] 3]
	gk_toUserNum $gk_entrantUserNum $canvas create line $x1 $y1 $x2 $y2
    }
}    
